<template>
    <div class="modal fade" id="largeModal" tabindex="-1" role="dialog">
        <div class="modal-dialog modal-lg" role="document">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="title" id="largeModalLabel">
                        {{ fields.title }}
                    </h4>
                </div>
                <div class="modal-body">
                    <div class="container row">
                        <div
                            v-if="!country"
                            class="col-lg-12 text-center align-self-center"
                        >
                            <div class="form-group">
                                <cool-select
                                    v-model="country"
                                    :items="countries"
                                    item-text="name"
                                    :loading="loading"
                                    :allowMobileScroll="false"
                                    :placeholder="fields.country"
                                    :inputElCustomAttributes="{
                                        id: 'inputCountry'
                                    }"
                                    :inputForTextClass="'form-control'"
                                    :inputStyles="inputStyles"
                                    disable-filtering-by-search
                                >
                                    <template #no-data>
                                        {{ noData ? fields.msg1 : fields.msg2 }}
                                    </template>
                                    <template #item="{ item }">
                                        <div class="item">
                                            <div>
                                                <span class="item-name">
                                                    <i
                                                        :class="
                                                            'flag flag-icon-' +
                                                                flag(item.name)
                                                        "
                                                        style="color: rgba(0,0,0,0); background-repeat: no-repeat"
                                                        >US</i
                                                    >
                                                    {{ item.name }}
                                                </span>
                                            </div>
                                        </div>
                                    </template>
                                    <template v-if="loading" #input-end>
                                        <!-- You can use your own loading spinner -->
                                        <img
                                            height="16px"
                                            src="https://i.imgur.com/mTNe6tr.gif"
                                            class="loading-indicator"
                                        />
                                    </template>
                                </cool-select>
                            </div>
                        </div>
                        <div v-show="country" class="col-lg-6 col-md-12 text-center">
                            <h3 v-if="country">
                                <i
                                    :class="
                                        'flag flag-icon-' + flag(country.name)
                                    "
                                    style="color: rgba(0,0,0,0); background-repeat: no-repeat"
                                    >US</i
                                >
                                {{ country.name }}
                            </h3 >
                            <button
                                v-if="country"
                                @click.prevent="country = null"
                                class="btn btn-block btn-primary"
                            >
                                {{
                                    fields.buttons
                                        ? fields.buttons.change_country
                                        : ""
                                }}
                            </button>
                            <div class="form-group">
                                <input
                                    v-model="m.title"
                                    :placeholder="
                                        fields.placeholders
                                            ? fields.placeholders.title
                                            : ''
                                    "
                                    type="text"
                                    class="form-control"
                                />
                            </div>
                            <div class="form-group">
                                <input
                                    v-model="m.price"
                                    :placeholder="
                                        fields.placeholders
                                            ? fields.placeholders.price
                                            : ''
                                    "
                                    type="number"
                                    class="form-control"
                                />
                            </div>
                            <div class="form-group">
                                <textarea
                                    v-model="m.description"
                                    :placeholder="
                                        fields.placeholders
                                            ? fields.placeholders.description
                                            : ''
                                    "
                                    class="form-control"
                                    rows="4"
                                ></textarea>
                            </div>
                            <div v-show="show" class="form-group">
                                <input
                                    @change.prevent="ifshow"
                                    type="file"
                                    :placeholder="
                                        fields.placeholders
                                            ? fields.placeholders.feature_image
                                            : ''
                                    "
                                    class="form-control"
                                    id="subirImagen"
                                    accept=".jpg,.png"
                                />
                            </div>
                            <div v-show="!show" id="editorImagen"></div>
                            
                        </div>
                        <div v-show="!show" class="col-lg-6 col-md-12 align-self-center">
                            <canvas id="previewImagen"></canvas>
                            <input
                                v-model="img"
                                type="hidden"
                                id="codeImagen"
                            />
                            <button
                                v-if="!show"
                                @click.prevent="show = true"
                                class="btn btn-block btn-primary"
                            >
                                {{
                                    fields.buttons
                                        ? fields.buttons.change_image
                                        : ""
                                }}
                            </button>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button
                        type="button"
                        class="btn btn-danger waves-effect"
                        data-dismiss="modal"
                    >
                        {{ fields.buttons ? fields.buttons.close : "" }}
                    </button>
                    <button
                        type="button"
                        @click.prevent="load"
                        class="btn btn-default btn-round waves-effect"
                    >
                        {{ fields.buttons ? fields.buttons.save : "" }}
                    </button>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import { CoolSelect } from "vue-cool-select";
export default {
    components: { CoolSelect },
    props: ["trans"],
    mounted() {
        this.get();
    },
    data() {
        return {
            rate:'',
            m: {},
            show:true,
            img: "",
            countries: [],
            fields: this.trans.create,
            country: null,
            //coool seleect
            selected: null,
            loading: false,
            timeoutId: null,
            noData: false,
            inputStyles: {
                "background-color": "rgba(0,0,0,0)",
                border: "1px solid #E3E3E3",
                "border-radius": "30px",
                color: "#2c2c2c",
                "line-height": "normal",
                "font-size": ".8571em",
                height: "auto",
                "-webkit-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-moz-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-o-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-ms-transition":
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                transition:
                    "color 0.3s ease-in-out, border-color 0.3s ease-in-out, background-color 0.3s ease-in-out",
                "-webkit-box-shadow": "none",
                "box-shadow": "none"
            }
        };
    },
    methods: {

        ifshow(e){
            if(e.target.files.length > 0){
                this.show = false
            }
        },
        flag(s) {
            let str = s.toLowerCase();
            return str.substr(0, 2);
        },
        async get() {
            let url = "/api/settings/rates";
            await axios.get(url).then(res => {
                this.rate = res.data
                res.data.forEach(e => {
                    this.countries.push(e.pais);
                });
                
            });
        },
        load() {
            let img = document.getElementById('codeImagen').value;
            this.m.feature_image = img.split(",")[1];
            this.m.rate_id = this.rate.find(e => e.pais.id == this.country.id).id;
            axios.post('/api/memberships',this.m).then(res => {
                location.reload();
            })
        }
    }
};
</script>
<style>
#inputCountry {
    padding: 10px 18px 10px 18px !important;
    background-color: rgba(0, 0, 0, 0);
    border: 1px solid #e3e3e3;
    border-radius: 30px;
    color: #2c2c2c;
    line-height: normal;
    font-size: inherit;
    height: auto;
    -webkit-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -moz-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -o-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -ms-transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    transition: color 0.3s ease-in-out, border-color 0.3s ease-in-out,
        background-color 0.3s ease-in-out;
    -webkit-box-shadow: none;
    box-shadow: none;
}
</style>
